#include <queue>
#include <iostream>

using namespace std;

int main()
{
	priority_queue<int> q;

	q.push(5);
	q.push(13);
	q.push(8);
	q.push(6);

	cout << "lecture de la file de priotite" << endl;
	while(!q.empty())
	{
		cout << q.top() << endl;
		q.pop();
	}
	return 0;
}

/*!F

Reprenons l'exemple prcdent :

  nous avons cette fois une file de priority :
  c'est en fait tres tres simple :

  C'est une file qui garde les lments dans l'ordre.
  Lancez le programme. Vous voyez que la file vous donne l'lment le plus grand d'abord.
  (* si vous voulez un tri diffrent, regardez le chapitre suivant sur les foncteurs.)

  L'algorithme s'appuie sur un vector. C'est l'algorithme du tri en "tas" que je n'expliquerai pas.
  
  Que dire d'autre sur les files de priorit ? 
  Contrairement au "set" que nous verrons plus loin, vous ne pouvez rcuprer QUE le premier lment,
  Donc si vous voulez le 2e lment, vous etes oblig d'enlever le premier pour y accder.

  Cet algorithme est rapide.

  Il s'agit toujours d'un algorithme en template : vous pouvez mettre des int, des double, ou "class machin"
  cependant, ATTENTION !!!!
  pour les int et les double, l'ordi sait comparer tout seul et savoir lequel est le plus grand.
  Mais si vous faites une "class machin" et que vous en voulez une file de priorit,
  il FAUT dire a l'ordinateur comment faire pour savoir, entre 2 instance de "class machine" laquelle est la plus grande, laquelle est la plus petite.
  Pour cela, 2 mthodes :
  - Vous surchargez l'oprateur < (voir surcharge des oprateurs dans les classes, chapitre C) et vous manipulez donc les files comme ici.
  - Vous utilisez un foncteur (chapitre suivant)

  note : inclure <queue> pour se servir des files des priorit.
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Les files de priorit
titreE: Priority queues.
meta: C++;STL
metaE: C++;STL
desc : Les files de priorit
descE: Priority queues.
cle  : priority_queue
*/
